'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = createDhtSensor;

var _nodeDhtSensor = require('node-dht-sensor');

var _nodeDhtSensor2 = _interopRequireDefault(_nodeDhtSensor);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function createDhtSensor(_ref) {
  var Service = _ref.Service;
  var Characteristic = _ref.Characteristic;

  return function () {
    function DhtSensor(log, config) {
      _classCallCheck(this, DhtSensor);

      this.log = log;
      this.name = config.name;
      this.type = config.sensorType;
      this.pin = config.gpioPin;
      this.cacheTimeout = config.cacheTimeout || 60 * 1000; // 1 minute

      this.temperature = 0;
      this.humidity = 0;
      this.lastUpdate = null;

      this.humidityService = new Service.HumiditySensor(this.name);
      this.temperatureService = new Service.TemperatureSensor(this.name);

      this.humidityService.getCharacteristic(Characteristic.CurrentRelativeHumidity).on('get', this.getValue.bind(this, 'humidity'));

      this.temperatureService.getCharacteristic(Characteristic.CurrentTemperature).on('get', this.getValue.bind(this, 'temperature'));
    }

    _createClass(DhtSensor, [{
      key: 'getValue',
      value: function getValue(what, callback) {
        var result = _nodeDhtSensor2.default.readSpec(this.type, this.pin);
        if (result.humidity !== 0 && result.temperature !== 0) {
          this.humidity = result.humidity;
          this.temperature = result.temperature;
          this.lastUpdate = Date.now();
        }

        if (Date.now() - this.lastUpdate >= this.cacheTimeout) {
          return callback(new Error('cannot get sensor data'), null);
        }

        switch (what) {
          case 'temperature':
            return callback(null, this.temperature);
          case 'humidity':
            return callback(null, this.humidity);
          default:
            return callback(new Error('cannot get unknown property \'' + what + '\''), null);
        }
      }
    }, {
      key: 'getServices',
      value: function getServices() {
        return [this.humidityService, this.temperatureService];
      }
    }]);

    return DhtSensor;
  }();
}